



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>第二十七课：滚轮事件,mouseenter与mouseleave事件的修复</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">第二十七课：滚轮事件,mouseenter与mouseleave事件的修复</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 12:14:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>滚轮事件</strong></p>
<p>jQuery核心库没有对mousewheel事件的差异性进行处理，但作为一个常用的事件，本文讲解一下。</p>
<p>mousewheel事件只有火狐浏览器不支持。mousewheel用于取得滚动距离的属性名为event.wheelDelta，往上滚一圈是120，往下滚一圈是-120.在IE6-8下，window无法绑定mousewheel事件，Opera，Safari，Chrome可以。</p>
<p>火狐下使用DOMMouseScroll来代替mousewheel事件。用于取得滚动距离的属性名为event.detail。往上滚一圈是-3，往下滚一圈是3.当我们按住ctrl,alt,shift键，再滚动鼠标滚轮时，detail的值就会变成-1和1.而且在按住ctrl键时，滑动滚轮还有缩放页面的功能，我们可以通过event.axis == event.HORIZONTAL_AXIS或event.axis == event.VERTICAL_AXIS得知是水平滚动还是垂直滚动。</p>
<p>兼容方案如下：</p>
<p>var wheel = function(obj,callback){</p>
<p>　　var wheelType = "mousewheel";</p>
<p>　　try{</p>
<p>　　　　document.createEvent("MouseScrollEvents"); &nbsp; //创建DOMMouseScroll事件，如果是火狐就会执行，不是火狐，就报错</p>
<p>　　　　wheelType = "DOMMouseScroll";</p>
<p>　　}catch(){}</p>
<p>　　addEvent(obj,wheelType,function(event){ &nbsp; &nbsp;//给对象obj绑定鼠标滚动事件</p>
<p>　　　　if("wheelDelta" in event){ &nbsp; //统一为120,其中正数为向上滚动，负数代表往下滚动</p>
<p>　　　　　　var delta = event.wheelDelta;</p>
<p>　　　　　　if(window.opera &amp;&amp; opera.version()&lt;10){ &nbsp;//opera9系列的方向跟上面的相反</p>
<p>　　　　　　　　delta = -delta</p>
<p>　　　　　　}</p>
<p>　　　　　　event.delta = Math.round(delta) / 120; //早期的safari会出现浮点数。为什么不赋值给wheelDelta，因为事件对象的原始属性是只读的，因此我们只能添加一个自定义属性delta来解决兼容性问题</p>
<p>　　　　}</p>
<p>　　　　else if("detail" in event){ &nbsp;//如果是火狐</p>
<p>　　　　　　event.wheelDelta = -event.detail * 40; &nbsp;//修复事件的wheelDelta属性，这样，火狐浏览器的这个属性就跟标准一样了</p>
<p>　　　　　　event.delta = event.wheelDelta / 120; &nbsp; //添加自定义属性delta解决兼容性问题</p>
<p>　　　　}</p>
<p>　　　　callback.call(obj,event);//这里的event.delta属性值是所有浏览器兼容的，往上一圈为1，往下一圈为-1.而event.wheelDelta属性在opera9系列和早期的safari中仍然存在问题，在其他浏览器下是正常的，往上一圈是120，往下一圈是-120.</p>
<p>　　})</p>
<p>}</p>
<p>滚轮事件触发页面的加载是电商领域必须知道的技术点，面试前一定要去了解一下整个流程。</p>
<p><strong>mouseenter与mouseleave事件</strong></p>
<p>在前端开发中，我们经常遇到隐藏弹出层或下拉菜单的需要。这就是所谓的显隐效果。我们经常使用mouseenter和mouseleave来实现。为什么不用mouseover和mouseout来实现呢，我来说一下这个问题：假设弹出层里面有无数子孙元素，我们的mouseout只监听弹出层最外面的大容器，我们很容易就移出这个大容器（鼠标移动到大容器的子元素，对于mouseout来说也算移出），但是实际上在鼠标还是在大容器范围内，会让判断失效。但mouseleave就不会，只有鼠标跑到大容器的外面才会触发，这是因为mouseenter和mouseleave不会冒泡。</p>
<p>但是webkit浏览器下不支持mouseenter和mouseleave事件。如何在不支持这两个事件的浏览器中模拟它们：</p>
<p>jQuery.each(</p>
<p>　　{　　</p>
<p>　　　　mouseenter:"mouseover",</p>
<p>　　　　mouseleave:"mouseout"</p>
<p>　　},</p>
<p>　　function(orig, fix){ &nbsp; //orig是mouseenter，fix是mouseover</p>
<p>　　　　jQuery.event.special[orig] = { &nbsp; &nbsp;//把mouseenter事件当做特殊事件处理</p>
<p>　　　　　　delegateType:fix, &nbsp; //用mouseover伪装mouseenter</p>
<p>　　　　　　bindType: fix,</p>
<p>　　　　　　handle:function(event){ &nbsp; //这时的event已经被修复了</p>
<p>　　　　　　　　var ret,target = this,handleObj = event.handleObj, related = event.relatedTarget;//对mouseover事件而言，事件的主目标是获得光标的元素，而相关元素就是那个失去光标的元素。类似地，对mouseout事件而言，事件的主目标是失去光标的元素，而相关元素则是获得光标的元素。IE下不支持这个属性，这个relatedTarget属性是在修复event时修复的，在IE下，它的值在mouseover时，等于fromElement（假设从div1移动到目标元素div2，那么这时的fromElement是div1），在mouseout时，等于toElement（假设从目标元素div2移出来到div1中，那么这时的toElement是div1）。</p>
<p>　　　　　　　　if(!related || (related ! == target &amp;&amp; !jQuery.contains(target,related))){ //这时related=div1，target = div2，并且div2不包含div1，就是if语句执行回调方法，模拟mouseenter，mouseleave。如果是在div2中移动，比如移动到div2的子元素div3中，这时会触发div2的mouseout事件，这时target就是div2，relatedTarget就是div3，但是target包含related，所以不会进入if语句，解决了mouseover显隐时的问题。同时也会触发div3的mouseover事件，然后冒泡到div2，这时target就是div2，relatedTarget也是div2，所以也不会进入if语句。</p>
<p>　　　　　　　　　　event.type = handleObj.origType; &nbsp; //事件的原始类型，也就是mouseenter</p>
<p>　　　　　　　　　　ret = handleObj.handler.apply(this,arguments); &nbsp;//执行回调方法</p>
<p>　　　　　　　　　　event.type = fix; &nbsp; //事件的修复类型，也就是mouseover</p>
<p>　　　　　　　　}</p>
<p>　　　　　　　　return ret;</p>
<p>　　　　　　}</p>
<p>　　　　}</p>
<p>　　}</p>
<p>)</p>
<p>related也有不存在的情况下，比如，从窗口外面直接进入到div2. 这样就能在所有浏览器下通过mouseenter和mouseleave实现显隐效果了。</p>
<p>加油！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxe5j8y.html">&lpar;转&rpar; 从0开始搭建SQL Server AlwaysOn 第三篇（配置AlwaysOn）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kp5w79.html">RSA原理及生成步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zvddx9.html">【Alpha】Daily Scrum Meeting第四次</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlv23x9.html">windows访问lnmp配置的虚拟域名</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p2zv48.html">内网渗透测试思路-FREEBUF</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e6ozxq.html">&lbrack;Tools&rsqb; maven-eclipse安装及配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd0rvgq.html">C&num;&period;Net 如何动态加载与卸载程序集（&period;dll或者&period;exe）3---- 动态加载Assembly应用程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k16jwr9.html">iOS 开发中常见的设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z3vr49.html">BZOJ3398&colon; &lbrack;Usaco2009 Feb&rsqb;Bullcow 牡牛和牝牛</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x6lkz8.html">linux系统的性能问题排除分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvvz1q.html">hadoop重新启动之后Datanode无法启动的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8merpvpq.html">LeetCode 238&period; Product of Array Except Self （去除自己的数组之积）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekg148.html">安装Wamp后&nbsp;Apache无法启动的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj22le9.html">小白学爬虫-在无GUI的CentOS上使用Selenium&plus;Chrome</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ogyzk8.html">深入理解linux系统下proc文件系统内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjr54z9.html">199&period; Binary Tree Right Side View 从右侧看的节点数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlldgexq.html">1&period; Tensorflow高效流水线Pipeline</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw411z9.html">汇编语言教材assembly language</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxvr79.html">PHP7&period;1扩展开发入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rny274q.html">python 阶乘</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qx7pve9.html">mrunit  for wordcount demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd7nnxq.html">Linux shell basic2 cat find tr</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd7mrjq.html">关于volatile和synchronized</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2prlv8.html">怎么学习计算电磁学【QUORA】</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z053xq.html">ASP&period;NET URL伪静态重写实现方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jw0nw8.html">Android网络之数据解析----SAX方式解析XML数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/39re5leq.html">Javascript 中的 in&comma; hasOwnProperty&comma; delete&comma; for&sol;in</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4rpj58.html">ralitive absolute</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kyo659.html">教你10分钟内在Windows上完成Rails开发环境的安装和配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv6eyj8.html">&lbrack;1&rsqb;Telerik Extensions for ASP&period;NET MVC 中文教程（转）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
